﻿Imports System.Drawing.Printing

Public Class MyPdfFile
    Inherits PrintDocument

    Private ReadOnly LogoFont As Font

    Private ReadOnly BodyFont As Font

    Public Property FirstName As String

    Public Property LastName As String

    Sub New(firstName As String, lastName As String)
        Me.FirstName = firstName
        Me.LastName = lastName
        LogoFont = New Font("Segoe UI", 18, FontStyle.Bold)
        BodyFont = New Font("Segoe UI", 12)
        SetDefaultPrinter()
    End Sub

    Private Sub SetDefaultPrinter()
        PrinterSettings.PrinterName = "Microsoft Print To PDF"
    End Sub

    Private Sub MyPdfFile_BeginPrint(sender As Object, e As PrintEventArgs) Handles Me.BeginPrint
        Debug.WriteLine("Started printing")
    End Sub

    Private Sub MyPdfFile_PrintPage(sender As Object, e As PrintPageEventArgs) Handles Me.PrintPage
        Debug.WriteLine("PrintPage")
        DrawHeader(e.Graphics)
        DrawBody(e.Graphics)
        DrawFooter(e.Graphics)
    End Sub

    Private Sub DrawHeader(g As Graphics)
        g.DrawString("My Company", LogoFont, Brushes.Black, New Point(50, 50))
    End Sub

    Private Sub DrawBody(g As Graphics)
        g.DrawString($"Hello, {FirstName} {LastName}", BodyFont, Brushes.Black, New Point(50, 250))
    End Sub

    Private Sub DrawFooter(g As Graphics)

    End Sub

    Private Sub MyPdfFile_EndPrint(sender As Object, e As PrintEventArgs) Handles Me.EndPrint
        Debug.WriteLine("Ended printing")
    End Sub

End Class
